
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const BA_CONTRACTID = '@xulfr.org/tutorial/bankaccount;1';
const BA_CLASSID = Components.ID('{54A9D6C7-EA1B-44FB-90EF-79AC20380269}');
const BA_IID = Components.interfaces.xfrIBankAccount;

// the constructor of the object
function bankAccountImpl(){
    // contain the total amount of all records
    this.mTotal = 0;

    // get a parser to create an empty document
    var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
         .createInstance(Components.interfaces.nsIDOMParser);

    // and store an empty document into a property
    this.mData = parser.parseFromString(
              "<?xml version='1.0'?><records />",
              "text/xml");
    
    // get the obs service and store it into a property
    this.obsSrv =  Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService);
}

bankAccountImpl.prototype = {

    classDescription: "Bank account component",
    classID:          BA_CLASSID,
    contractID:       BA_CONTRACTID,

    _notify : function(){
      // notify the observer for the topic "bankaccount-changed"
      this.obsSrv.notifyObservers(this, "bankaccount-changed", "");
    },

    // ----------   xfrIBankAccount interface
    get data() {
      return this.mData.documentElement;
    },

    get balance() { return this.mTotal; },

    addRecord : function(aLabel, aAmount){
      
      // insert a new <record> element into the xml document
      var rec = this.mData.createElement("record");
      
      this.mData.documentElement.appendChild(rec);
      
      // in the <record> element, add amount and label into attributes
      rec.setAttribute("label", aLabel);
      rec.setAttribute("amount", aAmount);
    
      // update the total
      this.mTotal += aAmount;
      //this.mTotal = this.mTotal + aAmount;

      // notify observers that the account has been changed
      this._notify();
    },

    removeRecord : function(aIndex){
        
        // retrieve the <record> element
        //??
        
        // retrieve the amount
        //??
        
        // remove the amount from the total
        //??
        
        // remove the <record> element from the xml document
        //?? 
        
        // notify observers that the account has been changed
        this._notify();
    },

    // --------------- nsISupports interface
    QueryInterface:  XPCOMUtils.generateQI ([
        Components.interfaces.xfrIBankAccount
    ])
}


function NSGetModule(aCompMgr, aFileSpec) {
  return XPCOMUtils.generateModule([bankAccountImpl]);
}

